// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.pmfm;

/**
 * <p>
 * Les méthodes sont rassemblées dans une liste qui couvre tous les
 * domaines pour lesquels il existe un paramètre.
 * </p>
 * <p>
 * La liste des méthodes est générique et porte sur toutes les
 * phases du processus de mesure des paramètres. Chaque méthode
 * n'est pas non plus systématiquement spécifique à l'une de ces
 * phases ou à une nature particulière de paramètre. En effet, une
 * méthode peut couvrir tout le cycle du processus et/ou être
 * utilisable pour une phase quelle que soit la nature du
 * paramètre.
 * </p>
 * <p>
 * Les méthodes peuvent être référencées par les paramètres à
 * différentes phases de leur processus de mesure que sont :
 * </p>
 * <p>
 * pour les paramètres biologique :
 * </p>
 * <p>
 * - le prélèvement et l'échantillonnage ;
 * </p>
 * <p>
 * - la conservation et le transport ;
 * </p>
 * <p>
 * - le fractionnement ;
 * </p>
 * <p>
 * - l'analyse ;
 * </p>
 * <p>
 * pour les paramètres environnementaux :
 * </p>
 * <p>
 * - l'observation ;
 * </p>
 */
public abstract class Method
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 6161971094760201154L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant unique de la méthode.Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * <p>
     * Description courte de la méthode.
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String description;

    /**
     * <p>
     * Description longue de la méthode.
     * </p>
     */
    public java.lang.String getDescription()
    {
        return this.description;
    }

    public void setDescription(java.lang.String description)
    {
        this.description = description;
    }

    private java.lang.String conditioning;

    /**
     * <p>
     * Description du conditionnement des échantillons ou des
     * prélèvements en vue de leur analyse.
     * </p>
     */
    public java.lang.String getConditioning()
    {
        return this.conditioning;
    }

    public void setConditioning(java.lang.String conditioning)
    {
        this.conditioning = conditioning;
    }

    private java.lang.String preparation;

    /**
     * <p>
     * Description de la préparation des échantillons ou des
     * prélèvements en vue de leur analyse.
     * </p>
     */
    public java.lang.String getPreparation()
    {
        return this.preparation;
    }

    public void setPreparation(java.lang.String preparation)
    {
        this.preparation = preparation;
    }

    private java.lang.String conservation;

    /**
     * <p>
     * Description de la méthode de conservation des échantillons ou
     * des prélèvements en vue de leur analyse.
     * </p>
     */
    public java.lang.String getConservation()
    {
        return this.conservation;
    }

    public void setConservation(java.lang.String conservation)
    {
        this.conservation = conservation;
    }

    private java.lang.String reference;

    /**
     * <p>
     * Référence nationale ou internationale de la méthode.
     * </p>
     * <p>
     * Référence à l'origine de la méthode.
     * </p>
     * <p>
     * Par exemple :
     * </p>
     * <p>
     * - "Bradford M., 1976. A rapid method for quantification of
     * protein utilizing the principle of dye binding. Anal. Biochem.
     * 72 : 248-264"
     * </p>
     * <p>
     * - "Circulaire 1988 Mer/Agriculture"
     * </p>
     * <p>
     * Nombre de lignes : 500
     * </p>
     */
    public java.lang.String getReference()
    {
        return this.reference;
    }

    public void setReference(java.lang.String reference)
    {
        this.reference = reference;
    }

    private java.lang.String rank;

    /**
     * <p>
     * Numéro de la méthode pour pouvoir "chainer" les méthodes. Il est
     * saisi par l'administrateur.
     * </p>
     */
    public java.lang.String getRank()
    {
        return this.rank;
    }

    public void setRank(java.lang.String rank)
    {
        this.rank = rank;
    }

    private java.lang.String handbookPath;

    /**
     * <p>
     * Lien vers un fichier PDF décrivant plus précisemment la méthode.
     * </p>
     */
    public java.lang.String getHandbookPath()
    {
        return this.handbookPath;
    }

    public void setHandbookPath(java.lang.String handbookPath)
    {
        this.handbookPath = handbookPath;
    }

    private java.util.Date creationDate;

    /**
     * <p>
     * Date système de création de la méthode. Cette date est
     * renseignée automatiquement.
     * </p>
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.sql.Timestamp updateDate;

    /**
     * <p>
     * Date de mise à jour de création de la méthode. Cette date est
     * renseignée automatiquement.
     * </p>
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }



    private fr.ifremer.adagio.core.dao.referential.Status status;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.Status getStatus()
    {
        return this.status;
    }

    public void setStatus(fr.ifremer.adagio.core.dao.referential.Status status)
    {
        this.status = status;
    }


    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Method))
        {
            return false;
        }
        final Method that = (Method)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Method}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Method}.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Method newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Method entity = new fr.ifremer.adagio.core.dao.referential.pmfm.MethodImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Method}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Method newInstance(java.lang.String name, java.lang.String rank, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Method entity = newInstance();
            entity.setName(name);
            entity.setRank(rank);
            entity.setCreationDate(creationDate);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Method}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Method newInstance(java.lang.String name, java.lang.String description, java.lang.String conditioning, java.lang.String preparation, java.lang.String conservation, java.lang.String reference, java.lang.String rank, java.lang.String handbookPath, java.util.Date creationDate, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Method entity = newInstance();
            entity.setName(name);
            entity.setDescription(description);
            entity.setConditioning(conditioning);
            entity.setPreparation(preparation);
            entity.setConservation(conservation);
            entity.setReference(reference);
            entity.setRank(rank);
            entity.setHandbookPath(handbookPath);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            return entity;
        }
    }
    
// Method.java merge-point
}