// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.feature.use;

/**
 * <p>
 * Paramètres de mise en oeuvre du navire. Il peut s'agir de
 * données d'observation comme de données de déclaration, mais liée
 * à comment est utilisé le navire et dans quelles conditions.
 * </p>
 * <p>
 * Par exemple, pour les donénes d'observation :
 * </p>
 * <p>
 * • profondeur de mer au début de l'opération, en mètre,
 * </p>
 * <p>
 * • profondeur de mer à la fin de l'opération, en mètre,
 * </p>
 * <p>
 * • déroulement de l'opération (normal, anormal, etc.)
 * </p>
 * <p>
 * • état de la mer lors durant l'opération : échelle de 0 à 9
 * (4=agitée, etc)
 * </p>
 * <p>
 * • trait rectiligne (oui/non)
 * </p>
 * <p>
 * • cout en gazoil,
 * </p>
 * <p>
 * • nombre d'engin perdu,
 * </p>
 * <p>
 * • cout des pertes,
 * </p>
 * <p>
 * • etc.
 * </p>
 * <p>
 * Par exemple, pour les données de déclaration :
 * </p>
 * <p>
 * • temps de pêche,
 * </p>
 * <p>
 * • temps de route (qui peut aussi etre calculé à l'exploitation),
 * </p>
 * <p>
 * • nombre d'opérations,
 * </p>
 * <p>
 * • etc.
 * </p>
 */
public abstract class VesselUseFeatures
    extends fr.ifremer.adagio.core.dao.data.vessel.feature.use.UseFeaturesImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 302953470445779139L;

    private java.lang.Integer isActive;

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Le navire est il actif pour la p&#233;riode concern&#233;
     * (Oui/Non).
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * &quot;1&quot; pour actif, &quot;0&quot; pour inactif, et
     * &quot;2&quot; pour inexistant (cas des
     * </p>
     * <p>
     * calendrier d'activit&#233; uniquement)
     * </p>
     * <p>
     * <br>    </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Cet attribut n'a pas &#233;t&#233; mis en tant que
     * UseMeasurement, car il est tr&#232;s
     * </p>
     * <p>
     * utile pour les diff&#233;rents traitements, et il reste un
     * attribut constant
     * </p>
     * <p>
     * et r&#233;current de toutes les caract&#233;ristiques
     * d'utilisation de navire
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.lang.Integer getIsActive()
    {
        return this.isActive;
    }

    public void setIsActive(java.lang.Integer isActive)
    {
        this.isActive = isActive;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.VesselUseMeasurement> vesselUseMeasurements = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.measure.VesselUseMeasurement>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.VesselUseMeasurement> getVesselUseMeasurements()
    {
        return this.vesselUseMeasurements;
    }

    public void setVesselUseMeasurements(java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.VesselUseMeasurement> vesselUseMeasurements)
    {
        this.vesselUseMeasurements = vesselUseMeasurements;
    }


    private fr.ifremer.adagio.core.dao.data.operation.Operation operation;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.operation.Operation getOperation()
    {
        return this.operation;
    }

    public void setOperation(fr.ifremer.adagio.core.dao.data.operation.Operation operation)
    {
        this.operation = operation;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeaturesOrigin> vesselUseFeaturesOrigins = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeaturesOrigin>();

    /**
     * <p>
     * Comment gérer cet attribut dans le cas d'une enquete ?
     * </p>
     * <p>
     * => REVOIR le texte ci-dessous :
     * </p>
     * <p>
     * Exemple pour les enquete d'activité :
     * </p>
     * <p>
     * - Si les informations issues de la prédocumentation électronique
     * ont été collées dans le calendrier sans modification, alors
     * Origine = Flux déclaratif. Si ce sont les informations du
     * calendrier l’année précédente qui sont copiées-collées
     * (Prédocumentation calendrier d’activité n-1) alors Origine =
     * Calendrier (n-1).
     * </p>
     * <p>
     * - Si des informations ont été pré-renseignées à partir des «
     * observations des captures à bord des navires de pêche », alors
     * Origine = Observation en mer, et à partir des « échantillonnages
     * des marées au débarquement », alors Origine = Observation au
     * débarquement. Dès lors qu’une information du bloc métier est
     * modifiée, l’Origine de l’information devra être repositionnée à
     * Enquête.
     * </p>
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeaturesOrigin> getVesselUseFeaturesOrigins()
    {
        return this.vesselUseFeaturesOrigins;
    }

    public void setVesselUseFeaturesOrigins(java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeaturesOrigin> vesselUseFeaturesOrigins)
    {
        this.vesselUseFeaturesOrigins = vesselUseFeaturesOrigins;
    }


    private fr.ifremer.adagio.core.dao.referential.location.Location basePortLocation;

    /**
     * <p>
     * Port d'exploitation, ou port d'attache (si pas d'activité).
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.location.Location getBasePortLocation()
    {
        return this.basePortLocation;
    }

    public void setBasePortLocation(fr.ifremer.adagio.core.dao.referential.location.Location basePortLocation)
    {
        this.basePortLocation = basePortLocation;
    }


    private fr.ifremer.adagio.core.dao.data.survey.activity.DailyActivityCalendar dailyActivityCalendar;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.activity.DailyActivityCalendar getDailyActivityCalendar()
    {
        return this.dailyActivityCalendar;
    }

    public void setDailyActivityCalendar(fr.ifremer.adagio.core.dao.data.survey.activity.DailyActivityCalendar dailyActivityCalendar)
    {
        this.dailyActivityCalendar = dailyActivityCalendar;
    }


    private fr.ifremer.adagio.core.dao.data.survey.activity.ActivityCalendar activityCalendar;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.activity.ActivityCalendar getActivityCalendar()
    {
        return this.activityCalendar;
    }

    public void setActivityCalendar(fr.ifremer.adagio.core.dao.data.survey.activity.ActivityCalendar activityCalendar)
    {
        this.activityCalendar = activityCalendar;
    }


    private fr.ifremer.adagio.core.dao.data.survey.fishingEffort.FishingEffortCalendar fishingEffortCalendar;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.fishingEffort.FishingEffortCalendar getFishingEffortCalendar()
    {
        return this.fishingEffortCalendar;
    }

    public void setFishingEffortCalendar(fr.ifremer.adagio.core.dao.data.survey.fishingEffort.FishingEffortCalendar fishingEffortCalendar)
    {
        this.fishingEffortCalendar = fishingEffortCalendar;
    }


    private fr.ifremer.adagio.core.dao.data.survey.economy.EconomicalSurvey economicalSurvey;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.economy.EconomicalSurvey getEconomicalSurvey()
    {
        return this.economicalSurvey;
    }

    public void setEconomicalSurvey(fr.ifremer.adagio.core.dao.data.survey.economy.EconomicalSurvey economicalSurvey)
    {
        this.economicalSurvey = economicalSurvey;
    }


    private fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    public void setFishingTrip(fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip)
    {
        this.fishingTrip = fishingTrip;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> fishingAreas = new java.util.HashSet<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> getFishingAreas()
    {
        return this.fishingAreas;
    }

    public void setFishingAreas(java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> fishingAreas)
    {
        this.fishingAreas = fishingAreas;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>fr.ifremer.adagio.core.dao.data.vessel.feature.use.UseFeaturesImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.vessel.feature.use.UseFeatures#equals(Object)
     */
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>fr.ifremer.adagio.core.dao.data.vessel.feature.use.UseFeaturesImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.vessel.feature.use.UseFeatures#hashCode()
     */
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures}.
         */
        public static fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures entity = new fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeaturesImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures newInstance(java.util.Date startDate, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, java.lang.Integer isActive)
        {
            final fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures entity = newInstance();
            entity.setStartDate(startDate);
            entity.setCreationDate(creationDate);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            entity.setProgram(program);
            entity.setIsActive(isActive);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures newInstance(java.util.Date startDate, java.util.Date endDate, java.util.Date creationDate, java.util.Date controlDate, java.util.Date validationDate, java.util.Date qualificationDate, java.lang.String qualificationComments, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.data.vessel.Vessel vessel, fr.ifremer.adagio.core.dao.administration.programStrategy.Program program, java.lang.Integer isActive, java.util.Collection<fr.ifremer.adagio.core.dao.data.measure.VesselUseMeasurement> vesselUseMeasurements, fr.ifremer.adagio.core.dao.data.operation.Operation operation, java.util.Collection<fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeaturesOrigin> vesselUseFeaturesOrigins, fr.ifremer.adagio.core.dao.referential.location.Location basePortLocation, fr.ifremer.adagio.core.dao.data.survey.activity.DailyActivityCalendar dailyActivityCalendar, fr.ifremer.adagio.core.dao.data.survey.activity.ActivityCalendar activityCalendar, fr.ifremer.adagio.core.dao.data.survey.fishingEffort.FishingEffortCalendar fishingEffortCalendar, fr.ifremer.adagio.core.dao.data.survey.economy.EconomicalSurvey economicalSurvey, fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip fishingTrip, java.util.Collection<fr.ifremer.adagio.core.dao.data.fishingArea.FishingArea> fishingAreas)
        {
            final fr.ifremer.adagio.core.dao.data.vessel.feature.use.VesselUseFeatures entity = newInstance();
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setCreationDate(creationDate);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            entity.setProgram(program);
            entity.setIsActive(isActive);
            entity.setVesselUseMeasurements(vesselUseMeasurements);
            entity.setOperation(operation);
            entity.setVesselUseFeaturesOrigins(vesselUseFeaturesOrigins);
            entity.setBasePortLocation(basePortLocation);
            entity.setDailyActivityCalendar(dailyActivityCalendar);
            entity.setActivityCalendar(activityCalendar);
            entity.setFishingEffortCalendar(fishingEffortCalendar);
            entity.setEconomicalSurvey(economicalSurvey);
            entity.setFishingTrip(fishingTrip);
            entity.setFishingAreas(fishingAreas);
            return entity;
        }
    }
    
// VesselUseFeatures.java merge-point
}